import java.net.*;
import java.io.*;
import java.util.Vector;

import java.io.IOException;
import java.net.InetAddress;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.UnknownHostException;
import java.nio.ByteBuffer;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.List;
import java.util.Random;

import org.apache.zookeeper.CreateMode;
import org.apache.zookeeper.KeeperException;
import org.apache.zookeeper.WatchedEvent;
import org.apache.zookeeper.Watcher;
import org.apache.zookeeper.ZooKeeper;
import org.apache.zookeeper.ZooDefs.Ids;
import org.apache.zookeeper.data.Stat;

import org.apache.log4j.*;

public class WebCrawlerApp implements Watcher {

	static ZooKeeper []zk = new ZooKeeper[12]; /* Metavliti tipou Zookeeper pou meso aftis tha epikinona o client me to server */
	//static ZooKeeper zk = null;
	static Integer mutex; /* */	
	//static Integer []mutex = new Integer[12]; /* */
	static URLQueue queue = new URLQueue();  /* Oura pou apothikevoume ta urls pou tha exagoume apo afta alla urls */ 
	static String root; /* To onoma tou root zNode */
	static int Currentdepth;  /* To trexon vathos crawlling */
	static int depth=1; /* To level afto dinete san parametros sto programma kai i anazitisi tha gini mexri to vathos afto*/
	static int numThreads=16; /* O arithmos twn thread pou tha trexoun ton Crawler */
	static int numResults=0; /* O arithmos twn urls pou o Crawler mas vriskei */
	static int hashSize=50; /* To size tou Hash Table(twn znodes sto 1o level tis Zookeeper) */
	static int numClients=12;
	/**
	 * Constructor of WebCrawlerApp class
	 *
	 * @param address
	 * @param num of client
	 */
	WebCrawlerApp(String address, int i) {
		if(zk[i] == null){
			try {
				System.out.println("Starting ZK:");
				zk[i] = new ZooKeeper(address, 500, this);
				mutex = new Integer(-1);
				System.out.println("Finished starting ZK: " + zk[i]);
			} catch (IOException e) {
				System.out.println(e.toString());
				zk[i] = null;
			}
		}
		//else mutex = new Integer(-1);
	}

	// I sinartisei pou parakolouthi to zNode kai enimeroni tous server oti iparxei kapia energia stin Zookeeper
	synchronized public void process(WatchedEvent event) {
		synchronized (mutex) {
			//System.out.println("Process0: " + event.getType());
			mutex.notify();
		}
	}	

	/**
	 * Sinartisei pou tiponi se arxio to teliko apotelesma me 
	 * ta monadika urls pou evgale o crawler mas.
	 * 
	 * */
	public static void printZookeeperToFile() throws KeeperException, InterruptedException, IOException {

		List<String> list = zk[0].getChildren(root  , true);
		Stat stat = null;
		// Create file
		FileWriter fstream = new FileWriter("URLs.txt");
		BufferedWriter out = new BufferedWriter(fstream);
		int k=1;
		for(int i=0;i<list.size();i++){
			String s=list.get(i);
			List<String> list1 = zk[0].getChildren(root + "/" + s , true);
			for(int j=0;j<list1.size();j++,k++){
				String s1=list1.get(j);
				byte[] b = zk[0].getData( root + "/"+ s + "/" + s1, false, stat);
				String retvalue = new String(b);
				try{
					//out.write(k + ":" + i + ":" + j + ":" + retvalue + "\n" );
					out.write(retvalue + "\n" );
					//Close the output stream
				}catch (Exception e){
					System.err.println("Error: " + e.getMessage());
				}

			}
		}
		out.close();
	}

	public static void run() throws KeeperException, InterruptedException {

		int newTaskLevel=0;
		newTaskLevel= queue.pop1();
		// Eksagoume ena Url apo tin oura twn urls kai an to url afto ine mikrotero 
		// apo to depth pou dosame san parametro tote kanoume extract tis istoselides 
		// pou exi o kodikas html gia ton url afto
		for (Object newTask = queue.pop(); newTask != null; newTaskLevel= queue.pop1(),newTask = queue.pop() ) {

			if(newTaskLevel>Currentdepth){
				Currentdepth=newTaskLevel;
			}
			if(Currentdepth < depth){
				process(newTask, newTaskLevel+1);
			}
			else{
				return;
			}

		}
	}

	public static void process(Object u, int taskLevel) {
		// The objects that we're dealing with here a strings for urls
		try {
			
			int threadID = (int)Thread.currentThread().getId();
			//System.out.println(threadID);
			URL pageURL =  (URL)u;

			String mimetype = pageURL.openConnection().getContentType();
			if (!mimetype.startsWith("text")) return;
			String rawPage = SaveURL.getURL(pageURL);
			String smallPage = rawPage.toLowerCase().replaceAll("\\s", " ");
			
			// Pernoume ola ta links apo URL pageURL kai ta valoume se ena Vector
			Vector links = SaveURL.extractLinks(rawPage,smallPage);

			// Gia kathe URL elegxoume an iparxei san zNode stin Zookeeper 
			for (int n = 0; n < links.size(); n++) {
				try {
					
					Stat stat = null;
					String url_name=(String) links.elementAt(n);
					String  hashString=null;
					hashString = new String(url_name);
					
					// Pernoume to hash Code tou string (URL string)
					int hashcodeOfHashStringtemp = (hashString.hashCode());	
					// Vlepoume se ti zNode antistixei to HashCode me tin hashFunction					
					Integer hashcodeOfHashString = new Integer((Math.abs(hashcodeOfHashStringtemp))%hashSize);
					// Pernoume ola ta childrens tou zNode me id hashcodeOfHashString
					List<String> list = zk[threadID%numClients].getChildren(root + "/" + hashcodeOfHashString.toString() , true);
					// urls might be relative to current page
					URL link = new URL(pageURL,(String) links.elementAt(n));
					
					// An den exi pedia o zNode tote prosthetoume ena pedi sto zNode me dedomena ena string pou antistixei sto string tou URL
					if(list.size()==0){
						ByteBuffer c = ByteBuffer.allocate(url_name.length());
						byte[] value;
						c.put(url_name.getBytes());
						value = c.array();
						zk[threadID%numClients].create(root + "/" + hashcodeOfHashString.toString() + "/" , value, Ids.OPEN_ACL_UNSAFE, 
								CreateMode.PERSISTENT_SEQUENTIAL);

						numResults++;
						queue.push(link,taskLevel); 
					}
					// An exei pedia tote elegxoume an kapio apo ta pedia ine idio me afto me to URL pou sigkrinoume
					else{

						int flag=0;
						for(int i=0;i<list.size();i++){	

							String s=list.get(i);
							byte[] b = zk[threadID%numClients].getData( root + "/"+ hashcodeOfHashString.toString() + "/" + s, false, stat);

							String retvalue = new String(b);
							// An isxei i sinthiki tote simeni iparxei idi to pedi mesa sto zNOde
							if(retvalue.equals(url_name)){
								flag=1;
								break;
							}
						}
						// To pedi den iparxei kai prosthetoume ena pedi mesa sto zNode
						if(flag==0){

							ByteBuffer c = ByteBuffer.allocate((url_name).length());
							byte[] value;
							c.put(url_name.getBytes());
							value = c.array();
							zk[threadID%numClients].create(root + "/" + hashcodeOfHashString.toString() + "/" , value, Ids.OPEN_ACL_UNSAFE, 
								CreateMode.PERSISTENT_SEQUENTIAL);
							numResults++;
							queue.push(link,taskLevel); 

						}
					}
				} catch (MalformedURLException e) {
					// Ignore malformed URLs, the link extractor might have failed.
				}
			}
		} catch (Exception e) {
			// e.printStackTrace();
			// process of this object has failed, but we just ignore it here
		}
	}

	static public class StartClient extends WebCrawlerApp {

		/**
		 * Constructor of StartClient class
		 *
		 * @param address
		 * @param name
		 * @param num of client
		 */
		StartClient(String address, String name, int i) {
			super(address, i);
			this.root = name;
			// Create ZK node name
			if (zk[i] != null) {
				try {
					Stat s = zk[i].exists(root, false);
					if (s == null) {
						zk[i].create(root, new byte[0], Ids.OPEN_ACL_UNSAFE,
								CreateMode.PERSISTENT);
					}
				} catch (KeeperException e) {
					System.out
					.println("Keeper exception when instantiating queue: "
							+ e.toString());
				} catch (InterruptedException e) {
					System.out.println("Interrupted exception");
				}
			}
		}

	}

	// I classi pou ksekina to kathe Thread na doulevi gia ton Crawler
	static public class PeriodicChecker extends Thread
	{
		@Override
		public void run()
		{
			try {

				WebCrawlerApp.run();
			} catch (KeeperException | InterruptedException e) {

				e.printStackTrace();
			}
		}
	}

	public static void main(String args[]) throws Exception {


		try {
			if (args.length == 5) {
				Currentdepth = 0;
				depth = Integer.parseInt(args[3]);
				numThreads = Integer.parseInt(args[4]);
				if(depth>1)
					hashSize = 50;
					//hashSize=(int)(Math.pow(2, depth))*100;
				
				zk[0]=null;zk[1]=null;zk[2]=null;zk[3]=null;zk[4]=null;zk[5]=null;
				zk[6]=null;zk[7]=null;zk[8]=null;zk[9]=null;zk[10]=null;zk[11]=null;
				// Dinoume to onoma tou root znode pou to pirame san parametro apo to command line.
				String AppName = new String(args[2]);
				
				// Ksekinoume ena client pou tha epikinonei me tous servers tis Zookeeper.
				StartClient Client1 = new StartClient(args[1],  AppName, 0);
				StartClient Client2 = new StartClient(args[1],  AppName, 1);
				StartClient Client3 = new StartClient(args[1],  AppName, 2);
				StartClient Client4 = new StartClient(args[1],  AppName, 3);
				StartClient Client5 = new StartClient(args[1],  AppName, 4);
				StartClient Client6 = new StartClient(args[1],  AppName, 5);
				StartClient Client7 = new StartClient(args[1],  AppName, 6);
				StartClient Client8 = new StartClient(args[1],  AppName, 7);
				StartClient Client9 = new StartClient(args[1],  AppName, 8);
				StartClient Client10 = new StartClient(args[1],  AppName, 9);
				StartClient Client11 = new StartClient(args[1],  AppName, 10);
				StartClient Client12 = new StartClient(args[1],  AppName, 11);
				
				queue.push(new URL(args[0]),Currentdepth);
				
				long startTime = System.currentTimeMillis();
				
				// Dimiourgia twn arxikwn zNodes pou tha ilopioun stin korifi tis Zookeeper ti logiki tou hashing 
				for(int c=0;c<hashSize;c++){
					Integer c_s = new Integer(c);
					zk[c%numClients].create(root + "/" + c_s.toString() , new byte[0], Ids.OPEN_ACL_UNSAFE, 
							CreateMode.PERSISTENT);
				}
				//run();
				
				// Dimiourgia twn Threads pou tha ekteloun tin polinimatiki efarmogi
				Thread []runner = new Thread[numThreads];
				
				for(int c1=0; c1<numThreads; c1++){
					runner[c1] = new PeriodicChecker();
				}

				// Arxizi to ptroto thread na kani crawling
				runner[0].start();

				// Ta ipolipa threads kimizonte etsi oste otan ksekinisoun na vroun urls stin oura kai mporesoun na doulepsoun
				// Diaforetika tha evgenan apo tin run() kai tha termatizan afinontas to thread 1 na doulevi mono tou
				for(int c1=1; c1<numThreads; c1++){
					runner[c1].sleep(500);

				}

				// Ksekinoume ta ipolipa threads
				for(int c1=1; c1<numThreads; c1++){
					runner[c1].start();	
				}

				// Kanoume join gia na perimenei i main ta nimata na termatisoun
				try{
					for(int c1=0; c1<numThreads; c1++){
						runner[c1].join();
					} 
				}catch(InterruptedException ie){  
					ie.printStackTrace();  
				}
				
				// Ipologismos tou xronou kai posa apotelesmata paraxthikan
				long endTime   = System.currentTimeMillis();
				long totalTime = endTime - startTime;
				System.out.println("\nZookeeperWebCrawler: (Initial URL = " + args[0] + ")\n"  + numResults + 
						" results(urls) in " + totalTime/1000 + "." + totalTime%1000 + 
						" seconds(depth " + depth + ")");
				
				// Tiponoume ola ta urls se ena arxio "URLs.txt"
				printZookeeperToFile();

				return;
			}
		} catch (Exception e) {
			System.err.println("An error occured: ");
			e.printStackTrace();	
		}

		System.err.println("Usage: java WebCrawlerApp <url> <connectString> <applicationname> <depth> <numThreads>");
	}
}